package io;

/**
 * @author user
 * 
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
import java.net.*;
import java.io.*;
import java.util.*;

public class locus2pir {
	public static void main(String[] args)  throws Exception{

        // data input

		for(int n=0;n<args.length;n++){
			String gi = GI(args[n]);
			System.out.println(gi);
			String SwissProt =GI2swissprot(gi);
			System.out.println(SwissProt);
			swissprot2GO(SwissProt);			
		}
	}

	public static String swissprot2GO(String query) {
		StringBuffer v = new StringBuffer();
		String result="";
		try {
			// set blast URL 

			URL helloURL = new URL("http://www.ebi.ac.uk/ego/QuickGO?mode=search&querytype=protein&query="+query);      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 0;
			while ((line = in.readLine()) != null) {
				if( (flag>0)&&(line.indexOf(">")<0)&&(line.indexOf("<")<0) ){
					if(line.length()>=8) System.out.println(line.substring(8));
				}
				if( line.indexOf("With")>=0 ) flag++;
			}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		return result;
	}


    public static String GI(String query){
		String result = definition(query);
		int pos1=result.indexOf("|")+1;
	    String tmp = result.substring(pos1);
		int pos2=tmp.indexOf("|");
		return tmp.substring(0,pos2);
    }

	public static String GI2swissprot(String query) {
		StringBuffer v = new StringBuffer();
		String result="";
		try {
			// set blast URL 

			URL helloURL = new URL("http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?db=nucleotide&val="+query);      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				int n=line.indexOf("Swiss-Prot:");
				if(n>=0) result = line.substring(n+11,line.length()-1);
				if(n>=0) break;
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		return result;
	}

	public static String GI2protein(String query) {
		StringBuffer v = new StringBuffer();
		String result="";
		try {
			// set blast URL 

			URL helloURL = new URL("http://www.ncbi.nlm.nih.gov/entrez/viewer.fcgi?db=nucleotide&val="+query);      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				int n=line.indexOf("Swiss-Prot:");
				if(n>=0) result = line.substring(n+11,line.length()-1);
				if(n>=0) break;
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		return result;
	}



	public static String definition(String query) {
		StringBuffer v = new StringBuffer(query);
		try {
			// set blast URL 

			URL helloURL = new URL("http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?db=Nucleotide&cmd=search&term="+query+"+");      
			// URL connection
			URLConnection con = helloURL.openConnection();
/*
			// set output
			con.setDoOutput(true);
			PrintWriter out = new PrintWriter(con.getOutputStream());
			// POST
			out.print("dna_type=normal;");
			out.print("database=ddbj;");
			out.print("amino_type=normal;");
			out.print("showmail=show;");
			out.print("number=loc;");
			out.print("acnumber=" + query + ";");
			out.print("submit;");
			
			
//			out.print("acnumber=HSLCATG;");
			out.close();
*/      
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				flag++;
				if (line.equals("<dd>")) flag=0;
				if ((flag==1)||(flag==2) ) v.append("\t" + line);
//				if (line.equals("</dd>")) flag=false;
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		return v.toString();
	}

	public static String[] search(String query) {
		Vector v = new Vector();
		try {
			// set blast URL 

			URL helloURL = new URL("http://www.ncbi.nlm.nih.gov/entrez/query.fcgi?db=Nucleotide&cmd=search&term="+query+"+");      
			// URL connection
			URLConnection con = helloURL.openConnection();
/*
			// set output
			con.setDoOutput(true);
			PrintWriter out = new PrintWriter(con.getOutputStream());
			// POST
			out.print("dna_type=normal;");
			out.print("database=ddbj;");
			out.print("amino_type=normal;");
			out.print("showmail=show;");
			out.print("number=loc;");
			out.print("acnumber=" + query + ";");
			out.print("submit;");
			
			
//			out.print("acnumber=HSLCATG;");
			out.close();
*/      
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			boolean flag = false;
			while ((line = in.readLine()) != null) {
				if (line.equals("<dd>")) flag=true;
				if (flag) v.add(line);
				if (line.equals("</dd>")) flag=false;
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		int size = v.size();
		String[] result = new String[size];
		for(int i=0;i<size;i++) result[i] = (String) v.get(i);
		return result;
	}
}

