package matrix;
import java.util.*;

import io.*;


public class findCDSblast { 
    disrand dis;
    MatrixLoad m; // original mutation matrix
	Jacobi jacobi;
	
	public static void main(String[] args) throws Exception{
		newMatrixLoad m0 = new newMatrixLoad();
        double kappa  = m0.kappa;
        double lambda = m0.lambda;
        
        String[] tmpdata;
        if(args.length>0){
    		tmpdata = fileload.loadLine0(args[0]);
        }else{
    		tmpdata = fileload.loadLine0();
        }

        // data input
		String[][] data = new String[0][0];
		if(tmpdata[0].charAt(0)=='>'){
			data = fastaFormat.translate(tmpdata);
		}else{
			data = blastFormat.translate(tmpdata);
		}
		for(int n=0;n<data[0].length;n++){
	      	String[][] data2 = blastFormat.translate(doBlast.search(data[1][n]));
	        int size = data2[0].length/2; // number of sequences
	        int orgLen = data[1][n].length();
	       	boolean[] CDS = new boolean[data[1][n].length()];
       		for(int j=0;j<data[1][n].length();j++) CDS[j]=false; // reset
	        for(int i=0;i<size;i++){
    	    	int len = data2[1][i*2].length();
	        	double[][] result = findCDS.areas( m0,data2[1][i*2],data2[1][i*2+1]);
		        for(int j=0;j<result.length;j++){
		    	    double E = findCDS.E(kappa,lambda,orgLen, result[j][2] );
		   		    if(E<0.01){
		   		    	AwkLike line = new AwkLike(data2[0][i*2]);
		   		    	int tmp = (new Integer(line.doller(2))).intValue(); 
		   		    	int start = (int)(result[j][0]+tmp);
		   		    	int end = (int)(result[j][1]+tmp);
		   		    	for(int k=start;k<=end;k++) CDS[k]=true;
		   	    	}
		        }
    	    }
    	    System.out.print(data[0][n]+ "\t");
        	if(CDS[0]) System.out.print(0 + "\t");
	        for(int j=1;j<data[1][n].length()-1;j++){
	        	if( !CDS[j-1]&&CDS[j] )  System.out.print(j + "\t");
	        	if( CDS[j]&&!CDS[j+1] )  System.out.print(j + "\t");
	        }
    	    if(CDS[data[1][n].length()-1]) System.out.print(0 + "\t");
        	System.out.println();
		}
    }
}
