package matrix;
import java.util.*;

import io.*;


public class findCDSblast3 { 
    disrand dis;
    MatrixLoad m; // original mutation matrix
	Jacobi jacobi;
	
	public static void main(String[] args) throws Exception{
		newMatrixLoad m0 = new newMatrixLoad();
        double kappa  = m0.kappa;
        double lambda = m0.lambda;
        
        String[] tmpdata;
        if(args.length>0){
    		tmpdata = fileload.loadLine0(args[0]);
        }else{
    		tmpdata = fileload.loadLine0();
        }

        // data input
		String[][] data = new String[0][0];
		if(tmpdata[0].charAt(0)=='>'){
			data = fastaFormat.translate(tmpdata);
		}else{
			data = blastFormat.translate(tmpdata);
		}
		for(int n=0;n<data[0].length;n++){
	      	String[][] data2 = blastFormat.translate(doBlastHuman.search(data[1][n]));
			int queryLen = blastFormat.queryLen(tmpdata);
	//		System.out.println(len);

		    Vector exonStart = new Vector();
		    Vector exonEnd = new Vector();
	    	Vector muki = new Vector();
		    Vector Elist = new Vector();
	        int size = data2[0].length/2; // number of sequences
			for(int i=0;i<size;i++){ // size = number of sequence pairs in the blast result
				//plus
	    		int len = data2[1][i*2].length();
	       		double[][] result = findCDS.areas( m0,data2[1][i*2+1],data2[1][i*2]);
		        for(int j=0;j<result.length;j++){
		    	    double E = findCDS.E(kappa,lambda,data2[1][i*2].length(), result[j][2] ); //changed
		   		    if(E<0.01){
	   			    	AwkLike line = new AwkLike(data2[0][i*2]);
	   			    	int tmp = (new Integer(line.doller(2))).intValue(); 
	   		    		int start = (int)(result[j][0]+tmp);
	   		    		int end = (int)(result[j][1]+tmp);
   			    		exonStart.add( new Integer(start) );
	   		    		exonEnd.add( new Integer(end) );
	   		    		muki.add("+");
	   		    		Elist.add(new Double(E));
		   	    	}
		        }
				//*/minus
	    		len = data2[1][i*2].length();
	       		result = findCDS.areas( m0,blastFormat.complement(data2[1][i*2+1]),blastFormat.complement(data2[1][i*2]));
		        for(int j=0;j<result.length;j++){
		    	    double E = findCDS.E(kappa,lambda,data2[1][i*2].length(), result[j][2] ); //changed
		   		    if(E<0.01){
	   			    	AwkLike line = new AwkLike(data2[0][i*2]);
	   			    	int tmp = (new Integer(line.doller(3))).intValue(); 
	   		    		int start = (int)(-result[j][0]+tmp);
	   		    		int end = (int)(-result[j][1]+tmp);
	   		    		exonStart.add( new Integer(start) );
	   		    		exonEnd.add( new Integer(end) );
	   		    		muki.add("-");
	   		    		Elist.add(new Double(E));
		   	    	}
		        }/**/
			}
		
			//output
			size = exonStart.size();
			for(int j=0;j<size;j++){ // size = number of CDS
				System.out.print(args[0]);
				System.out.print("\t");
				System.out.print("new");
				System.out.print("\t");
				System.out.print("CDS");
				System.out.print("\t");
				System.out.print( (exonStart.elementAt(j)).toString() );
				System.out.print("\t");
				System.out.print( (exonEnd.elementAt(j)).toString() );
				System.out.print("\t");
				System.out.print( (muki.elementAt(j)).toString() );
				System.out.print("\t");
				System.out.print( (Elist.elementAt(j)).toString() );
				System.out.println();			
			}
		} 
    }
}
