package matrix;
import java.util.*;

import io.*;
import java.net.*;
import java.io.*;

public class twinscanDataTest { 
    disrand dis;
    MatrixLoad m; // original mutation matrix
	Jacobi jacobi;
	
	public static void main(String[] args) throws Exception{
		newMatrixLoad m0 = new newMatrixLoad();
        double kappa  = m0.kappa;
        double lambda = m0.lambda;
        
        String[] tmpdata;
		String[][] data3 = fastaFormat.translate(mouse(args[0]));
		//**/fastaFormat.output(data3);
		String data4 = homData(args[0]);
        // data input
        String[][] data = cut(data3,data4); 
        //fastaFormat.output(data);
//*
		for(int n=0;n<data[0].length;n++){
	      	String[][] data2 = blastFormat.translate(doBlastHuman.search(data[1][n]));
	        int size = data2[0].length/2; // number of sequences
	        int orgLen = data[1][n].length();
	        if(orgLen>0){
		       	boolean[] CDS = new boolean[data[1][n].length()];
    	   		for(int j=0;j<data[1][n].length();j++) CDS[j]=false; // reset
	    	    for(int i=0;i<size;i++){
    	    		int len = data2[1][i*2].length();
	        		double[][] result = findCDS.areas( m0,data2[1][i*2+1],data2[1][i*2]);
			        for(int j=0;j<result.length;j++){
			    	    double E = findCDS.E(kappa,lambda,orgLen, result[j][2] );
			   		    if(E<0.01){
		   			    	AwkLike line = new AwkLike(data2[0][i*2]);
		   			    	int tmp = (new Integer(line.doller(2))).intValue(); 
		   		    		int start = (int)(result[j][0]+tmp);
		   		    		int end = (int)(result[j][1]+tmp);
			   		    	for(int k=start;k<=end;k++) CDS[k]=true;
			   	    	}
			        }
    	    	}
	    	    int startPos = (new Integer(data[0][n])).intValue();
    		    Vector exonStart = new Vector();
    		    Vector exonEnd = new Vector();
        		if(CDS[0]) exonStart.add( new Integer(startPos) );
    	    	int j=1;
	    	    for(j=1;j<data[1][n].length()-1;j++){  //find the edge
	        		if( !CDS[j-1]&&CDS[j] )  exonStart.add( new Integer(j+startPos));
	        		if( CDS[j]&&!CDS[j+1] )  exonEnd.add( new Integer(j+startPos));
		        }
    		    if(CDS[j]) exonEnd.add( new Integer(j+startPos));
    	    
				//output
				int CDSsize = exonEnd.size(); //
				if(CDSsize>exonStart.size()) CDSsize = exonStart.size();
				for(j=0;j<CDSsize;j++){
					System.out.print(args[0]);
					System.out.print("\t");
					System.out.print("new");
					System.out.print("\t");
					System.out.print("CDS");
					System.out.print("\t");
					System.out.print( (exonStart.elementAt(j)).toString() );
					System.out.print("\t");
					System.out.print( (exonEnd.elementAt(j)).toString() );
					System.out.println();
				}
			}/**/
		}
    }
    
	public static String[][] cut(String[][] data0, String target){
		int len = data0[1][0].length();
		int flag=0;int start=0;
		Vector seq = new Vector();
		Vector pos = new Vector();
		StringBuffer SB = new StringBuffer();
		for(int i=0;i<len;i++){
			char c=target.charAt(i);
			if(c=='2'){
				if(flag==0){
					seq.add(SB.toString());
					pos.add((new Integer(start)).toString());
					SB=new StringBuffer();
					flag=1;
				}
			}else{
				SB.append(data0[1][0].charAt(i));
				if(flag==1) start = i;
				flag=0;
			}
		}
		int size = seq.size();
    	String[][] result = new String[2][size];
    	for(int i=0;i<size;i++){
    		result[0][i] = (String) pos.elementAt(i);;
    		result[1][i] = (String) seq.elementAt(i);
    	}
    	return result;
    }

	public static String[] mouse(String query) {
		Vector v = new Vector();
		try {
			// set blast URL 

			URL helloURL = new URL("http://genes.cs.wustl.edu/datasets/mm_fasta/"+query+".mm.fa");      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				v.add(line);
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		int size = v.size();
		String[] result = new String[size];
		for(int i=0;i<size;i++){
			result[i] = (String) v.elementAt(i);
		}
		return result;
	}

	public static String homData(String query) {
		StringBuffer v = new StringBuffer();
		try {
			// set blast URL 

			URL helloURL = new URL("http://genes.cs.wustl.edu/datasets/mm_conseq/"+query+".mm.fa.conseq");      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				v.append(line);
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		return v.toString();
	}
}
