package matrix;
import java.util.*;

import io.*;
import java.net.*;
import java.io.*;

public class twinscanDataTest2 { 
    disrand dis;
    MatrixLoad m; // original mutation matrix
	Jacobi jacobi;
	
	public static void main(String[] args) throws Exception{
		newMatrixLoad m0 = new newMatrixLoad();
        double kappa  = m0.kappa;
        double lambda = m0.lambda;
        
        String[] tmpdata = fileload.loadLine0(args[0]);
		String[][] data2 = blastFormat.translate(tmpdata);
//        fastaFormat.output(data2);
		int queryLen = blastFormat.queryLen(tmpdata);
//		System.out.println(len);

	    Vector exonStart = new Vector();
	    Vector exonEnd = new Vector();
	    Vector muki = new Vector();
	    Vector Elist = new Vector();
        int size = data2[0].length/2; // number of sequences
		for(int i=0;i<size;i++){ // size = number of sequence pairs in the blast result
			//plus
    		int len = data2[1][i*2].length();
       		double[][] result = findCDS.areas( m0,data2[1][i*2+1],data2[1][i*2]);
	        for(int j=0;j<result.length;j++){
	    	    double E = findCDS.E(kappa,lambda,queryLen, result[j][2] );
	   		    if(E<0.01){
   			    	AwkLike line = new AwkLike(data2[0][i*2]);
   			    	int tmp = (new Integer(line.doller(2))).intValue(); 
   		    		int start = (int)(result[j][0]+tmp);
   		    		int end = (int)(result[j][1]+tmp);
   		    		exonStart.add( new Integer(start) );
   		    		exonEnd.add( new Integer(end) );
   		    		muki.add("+");
   		    		Elist.add(new Double(E));
	   	    	}
	        }
			//*/minus
    		len = data2[1][i*2].length();
       		result = findCDS.areas( m0,blastFormat.complement(data2[1][i*2+1]),blastFormat.complement(data2[1][i*2]));
	        for(int j=0;j<result.length;j++){
	    	    double E = findCDS.E(kappa,lambda,queryLen, result[j][2] );
	   		    if(E<0.01){
   			    	AwkLike line = new AwkLike(data2[0][i*2]);
   			    	int tmp = (new Integer(line.doller(3))).intValue(); 
   		    		int start = (int)(-result[j][0]+tmp);
   		    		int end = (int)(-result[j][1]+tmp);
   		    		exonStart.add( new Integer(start) );
   		    		exonEnd.add( new Integer(end) );
   		    		muki.add("-");
   		    		Elist.add(new Double(E));
	   	    	}
	        }/**/

		}
		
		//output
		size = exonStart.size();
		for(int j=0;j<size;j++){ // size = number of CDS
			System.out.print(args[0]);
			System.out.print("\t");
			System.out.print("new");
			System.out.print("\t");
			System.out.print("CDS");
			System.out.print("\t");
			System.out.print( (exonStart.elementAt(j)).toString() );
			System.out.print("\t");
			System.out.print( (exonEnd.elementAt(j)).toString() );
			System.out.print("\t");
			System.out.print( (muki.elementAt(j)).toString() );
			System.out.print("\t");
			System.out.print( (Elist.elementAt(j)).toString() );
			System.out.println();			
		}
    }

    
	public static String[][] cut(String[][] data0, String target){
		int len = data0[1][0].length();
		int flag=0;int start=0;
		Vector seq = new Vector();
		Vector pos = new Vector();
		StringBuffer SB = new StringBuffer();
		for(int i=0;i<len;i++){
			char c=target.charAt(i);
			if(c=='2'){
				if(flag==0){
					seq.add(SB.toString());
					pos.add((new Integer(start)).toString());
					SB=new StringBuffer();
					flag=1;
				}
			}else{
				SB.append(data0[1][0].charAt(i));
				if(flag==1) start = i;
				flag=0;
			}
		}
		int size = seq.size();
    	String[][] result = new String[2][size];
    	for(int i=0;i<size;i++){
    		result[0][i] = (String) pos.elementAt(i);;
    		result[1][i] = (String) seq.elementAt(i);
    	}
    	return result;
    }
//http://genome.ucsc.edu/cgi-bin/hgTables?hgsid=38117715&org=Mouse&db=mm4&hgta_group=genes&hgta_track=twinscan&hgta_table=twinscan&hgta_regionType=range&position=chr7%3A34297896-34328428&hgta_outputType=primaryTable&hgta_outFileName=&hgta_compressType=hgta_compressNone&hgta_doTopSubmit=Get+Output

//http://genome.ucsc.edu/cgi-bin/hgTables?hgsid=38117715&org=Mouse&db=mm4&hgta_group=genes&hgta_track=twinscan&hgta_table=twinscan&hgta_regionType=range&position=chr17%3A33143094-33150644&hgta_outputType=primaryTable&hgta_outFileName=&hgta_compressType=hgta_compressNone&hgta_doTopSubmit=Get+Output
//http://genome.ucsc.edu/cgi-bin/hgTables?hgsid=38117715&org=Human&db=hg17&hgta_group=genes&hgta_track=twinscan&hgta_table=twinscan&hgta_regionType=range&position=chr17%3A33143094-33150644&hgta_outputType=primaryTable&hgta_outFileName=&hgta_compressType=hgta_compressNone&hgta_doTopSubmit=Get+Output

	public static String[] mouse(String query) {
		Vector v = new Vector();
		try {
			// set blast URL 

			URL helloURL = new URL("http://genes.cs.wustl.edu/datasets/mm_fasta/"+query+".mm.fa");      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				v.add(line);
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		int size = v.size();
		String[] result = new String[size];
		for(int i=0;i<size;i++){
			result[i] = (String) v.elementAt(i);
		}
		return result;
	}

	public static String homData(String query) {
		StringBuffer v = new StringBuffer();
		try {
			// set blast URL 

			URL helloURL = new URL("http://genes.cs.wustl.edu/datasets/mm_conseq/"+query+".mm.fa.conseq");      
			// URL connection
			URLConnection con = helloURL.openConnection();
			// get input
			BufferedReader in = new BufferedReader(
                                new InputStreamReader(
                                con.getInputStream()));
 
			// get the search result
			String line;
			int flag = 3;
			while ((line = in.readLine()) != null) {
				v.append(line);
	    	}
	      	// close input
	    	in.close();
	    } catch (IOException e) {
   			return null;
		}
		return v.toString();
	}
}
